using namespace std;

#include <sstream>
#include <stdio.h>
#include <sys/types.h>
#include <sys/fcntl.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <iostream>
#include <sys/types.h>
#include <fstream>
#include <sys/un.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include "config.h"

int clientPort;
int serverPort;
string serverHost;
int bufferSize = 32768;

void error(char *msg) {
    perror(msg);
    exit(EXIT_FAILURE);
}

/**
 * Obsouzi prichozi zpravu
 */
void *listen(void* arg) {
    int sockfd, newsockfd, clilen;
    char buffer[BUFFER_SIZE];
    struct sockaddr_in serv_addr, cli_addr;

    sockfd = socket(AF_INET, SOCK_STREAM, 0); // Vytvorime socket
    if (sockfd < 0) {
        error(ERR_OPENING_SOCKET);
    }
    bzero((char *) &serv_addr, sizeof(serv_addr)); // Vynulujem strukturu adresy serveru
    serv_addr.sin_family = AF_INET; // Nastavime parametry
    serv_addr.sin_addr.s_addr = INADDR_ANY; 
    serv_addr.sin_port = htons(clientPort); // Nastavime port
    if (bind(sockfd, (struct sockaddr *) &serv_addr, sizeof(serv_addr)) < 0) { // Otevre
        error(ERR_BINDING);
    }
    listen(sockfd, 5); // Poslouchame

    clilen = sizeof(cli_addr);

    cout << LISTENING_ON << clientPort << endl;

    while (newsockfd = accept(sockfd, (struct sockaddr *) &cli_addr, (socklen_t*) &clilen)) { // Cekame na prichozi spojeni
        if (newsockfd < 0) {
            error(ERR_ON_ACCEPT);
        }
        bzero(buffer, BUFFER_SIZE); // Vyprazdnime buffer
        if(read(newsockfd,buffer, BUFFER_SIZE) < 0) {
            error(ERR_ON_READING);
        }
        cout << RECIEVED << buffer << "\n" << endl; // Vypisem co jsme ziskali 
    }
}

/**
 * Posle zpravu na host:port
 */
void sendMessage(string host, int port) {
    int sockfd;
    struct sockaddr_in serv_addr;
    struct hostent *server;
    string msg;
    std::stringstream out;
    char buffer[BUFFER_SIZE];
    char tmp[BUFFER_SIZE];
    char msg2[BUFFER_SIZE];
    char ch;

    if((sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0) { // Vytvorime socket
        error(ERR_OPENING_SOCKET);
    }
    if ((server = gethostbyname(host.c_str())) == NULL) { // Zjistime si informace o Serveru
        error(ERR_NO_SUCH_HOST);
    }
    bzero((char *) &serv_addr, sizeof(serv_addr)); // Vynulujem promennou adresy serveru
    serv_addr.sin_family = AF_INET;
    bcopy((char *)server->h_addr, (char *)&serv_addr.sin_addr.s_addr, server->h_length); // Zkopirujeme si adresu serveru
    serv_addr.sin_port = htons(port); // Naplnime hodnotu portu
    if ( connect(sockfd, (struct sockaddr *) &serv_addr, sizeof(serv_addr)) < 0) { // Pokusime se pripojit
        error(ERR_CONNECTING);
    }

    out << clientPort;
    msg = out.str(); // Na zacatek zpravy dame port na kterem poslouchame (stupidni cpp)
    bzero(buffer, BUFFER_SIZE); // Vyprazdnime buffer

    strcpy(tmp, out.str().c_str()); // Do tmp si ulozime port
    strcat(tmp, SEPARATOR); // Na konec tmp ulozime #

    srand(port);
    ch = rand() % 96 + 33; // Nas oblibeny znak, ktery budeme posilat
    for (int i = 0; i < CHAR_COUNT; i++) { // loopujeme
        msg2[i] = ch;
    }
    strcat(tmp, msg2); // Pripojime do zpravy nejaky ty znaky

    cout << SENDING << tmp << endl;

    if(write(sockfd, tmp, strlen(tmp)) < 0) {
         error(ERR_WRITTING);
    }
    bzero(tmp, BUFFER_SIZE);
}

int main(int argc, char *argv[]) {

    if (argc != 4) { // neni spravny pocet vstupnich parametru
        cout << USAGE << endl;
        cout << EXAMPLE << endl;
        exit(EXIT_FAILURE);
    }

    clientPort = atoi(argv[1]); // port klienta
    serverHost = argv[2]; // host serveru
    serverPort = atoi(argv[3]); // port serveru

    pthread_t t1;
    if ( pthread_create(&t1, NULL, listen, NULL) != 0 ) { // vytvorime vlakno pro poslouchani na odpoved od serveru
        cout << PTHREAD_CREATE_ERROR << endl;
        abort();
    }

    while(1) {
        sendMessage(serverHost, serverPort);
        int wait = rand() % MAX_WAIT_TIME;
        wait += 2;
        cout << WAITING << wait << "s" << endl;
        sleep(wait);
    }

    return 0;
}
