#define NUM_THREADS     5
#include "Config.h"
#include "Messages.h"
#include <errno.h>
#include <fstream>
#include <iostream>
#include <netdb.h>
#include <netinet/in.h>
#include <pthread.h>
#include <queue>
#include <sstream>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <string>
#include <sys/fcntl.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/un.h>
#include <time.h>
#include <unistd.h>
#include <sys/timeb.h>

pthread_mutex_t queue_mutex;
int bufferSize2 = 32768;
int numbers[65000];
queue<string> waitingMessages;
queue<int> waitingPorts;
queue<timeb> waitingTime;
vector<u_long> foreignIpVector;
vector<int> foreignPorts;
int times_a = 0;
int times_b = 0;
int times_c = 0;
int count_a = 0;
int count_b = 0;
int count_c = 0;

string currentMessage;
string configFile = "config.cfg";
struct timeb timeIn;
struct timeb timeOut;
struct timeb tim1;
struct timeb tim2;

void shout(char *msg) {
    perror(msg);
}

/**
 * Paralelni poslani zpravy jednomu klientovi
 */
void *threadMessage(void* arg) {
    int id = *(int *)arg;

    time_t start,end;
    timespec tsStart, tsEnd;
    double diff;
    time (&start);

    u_long myIp = foreignIpVector[id];
    int myPort = foreignPorts[id];
    string myMessage = currentMessage;

    cout << "Posilam: '" << myMessage[1] << "' do " << myPort << " (id:" << id << ")" << endl;
    int sockfd, portno, n;
    struct sockaddr_in serv_addr;
    struct hostent *server;

    char buffer[bufferSize2];
    portno = myPort;
    sockfd = socket(AF_INET, SOCK_STREAM, 0);
    if (sockfd < 0) {
        shout("Nemohu otevrit socket :(");
    }
    server = gethostbyname("localhost");
    if (server == NULL) {
        fprintf(stderr,"Takovy hostitel neexistuje :(");
        exit(0);
    }
    bzero((char *) &serv_addr, sizeof(serv_addr));
    serv_addr.sin_family = AF_INET;
    bcopy((char *)server->h_addr, (char *)&serv_addr.sin_addr.s_addr, server->h_length); // naplnime hodnoty
    serv_addr.sin_port = htons(portno);
    serv_addr.sin_addr.s_addr = myIp;
    if ( connect(sockfd, (struct sockaddr *) &serv_addr, sizeof(serv_addr)) < 0) { // pripojime se k danemu klientu
        return NULL;
    }

    strcpy(buffer, myMessage.c_str()); // nacteme si zpravu

    if( write(sockfd, buffer,strlen(buffer)) < 0) { // odeslem zpravu
         shout("Chyba zapisovani do socketu :(");
    }
    bzero(buffer, bufferSize2);

    time (&end);
    diff = difftime (end,start);

    cout << "Cas posilani: " << diff << endl;

    return NULL;
}

/**
 * Zde zacina nase nove vlakno
 */
void *sending(void* arg) {
    pthread_t myThreads[1000000];
    unsigned int i = 0;
    vector<PortRange> ranges;
    vector<int> fromV;
    vector<int> toV;

    FILE * pFile;
    pFile = fopen (configFile.c_str(), "r"); // nacteme si nastaveni
    while (!feof(pFile)) {
        char line[1001];
        char * pch;

        fgets (line , 1000 , pFile);

        pch = strchr(line, '-');

        char tmp1[1000];
        char tmp2[1000];

        strncpy(tmp1, line, pch - line);
        strcpy(tmp2, pch + 1);

        tmp1[pch - line] = 0;

        int from, to;
        from = atoi(tmp1);
        to = atoi(tmp2);

        fromV.push_back(from);
        toV.push_back(to);

    }

    cout << "Nalezene skupiny:" << endl;
    for(unsigned int i = 0; i < fromV.size(); i++) { // vypisem informace o skupinach
        cout << i << "     " << fromV[i] << " - " << toV[i] << endl;
    }

    fclose (pFile);

    while(1) { // nekonecna smycka
        time_t start2, end2;
        double diff2;
        time (&start2);

        bool empty = true;
        int port = 0;

        pthread_mutex_lock(&queue_mutex); // lockneme mutex je dulezity proto, abychom si neprepisovali frontu zprav
        if(!waitingMessages.empty()) { // pokud na nas ceka nejaka zprava
            string msg = waitingMessages.front(); // vezmeme posledni
            waitingMessages.pop(); // smazem ji
            timeb tmp = waitingTime.front();
            waitingTime.pop();
            currentMessage = msg; // ulozime si ji
            ftime (&timeOut); // zmerime cas
            port = waitingPorts.front(); // vratime si info o cekajicim portu
            waitingPorts.pop(); // odstranime tento z fronty
            //double diff = difftime (timeOut, timeIn); // spocitame jak dlouho zprava cekala
            long diff = timeOut.time*1000 + timeOut.millitm - tmp.time*1000 - tmp.millitm;
            int k = count_b;
            times_b = (k*times_b) / (k+1) + diff / (k+1);
            //cout << "Cekaci doba zpravy: " << diff << endl;
            empty = false;
        } else {
            empty = true;
        }
        pthread_mutex_unlock(&queue_mutex); // odemkneme mutex

        if (!empty) { // mame-li co posilat
            ftime(&tim1);
            unsigned int start = i;
            for(unsigned int j = start; j < (foreignIpVector.size() + start); j++) { // pro vsechny klienty v teto skupine

                bool skip = false;
                int group = -1;
                for(unsigned int i = 0; i < fromV.size(); i++) { // prochazime vsechny skupiny portu
                    if ( (fromV[i] < port) && (port < toV[i]) ) { // a poznamename si skupinu
                        group = i;
                        break;
                    }
                }
                cout << "Skupina: " << group << endl;
                if (group != -1) { // existuje ta skupina vubec?
                    if ( (fromV[group] < foreignPorts[j]) && (foreignPorts[j] < toV[group]) ) { // chceme to tomuto poslat?
                        skip = false;
                    } else {
                        skip = true;
                    }
                } else {
                    skip = false;
                }

                if (skip) { // jestlize jsme neprosli jednou z podminek
                    continue;
                }
                pthread_create(&myThreads[j], NULL, threadMessage, &j); // Zpravu budeme posilat ve vedlejsim vlakne

                sleep(1); // cekame pred dalsim overenim
            }

            ftime(&tim2);
            long diff1 = tim2.time*1000 + tim2.millitm - tim1.time*1000 - tim1.millitm;
            //time (&end2); // merime cas
            //diff2 = difftime (end2, start2);
            int k = count_c;
            //cout << "k = " << k << ", times_c = " << times_c << ", diff1 = " << diff1 << endl;
            times_c = (k*times_c)/(k+1) + diff1/(k+1);
            count_c++;
            //cout << "Nyni jsme posilali: " << diff1 << endl;
        } else { // nemame-li co posilat
            sleep(1);
        }

        cout << "Statistiky: " << times_a << " | " << times_b << " | " << times_c << endl;
    }
    return NULL;
}

/**
 * Konstruktor
 */
Messages::Messages() {
    for (int i = 0; i < 64000; i++) {
        numbers[i] = i;
    }

    waitingMessages.empty(); // vyprazdnime buffer zprav
    pthread_t t1;
    if ( pthread_create(&t1, NULL, sending, &waitingMessages) != 0 ) { // Zpravy budou posilany ve vlastnim vlakne
        cout << "Nelze vytvorit vlakno odesilani zprav :(" << endl;
        abort();
    }
}

void Messages::addClient(u_long strangeIP, int port) {
    bool found = false;

    for (unsigned int i = 0; i < foreignIpVector.size(); i++) {
        u_long tmpIp = foreignIpVector[i];
        int tmpPort = foreignPorts[i];
        if ((strangeIP == tmpIp) && (port == tmpPort)) {
            found = true;
            break;
        }
    }

    if (!found) {
        foreignIpVector.push_back(strangeIP);
        foreignPorts.push_back(port);
    }

}

void Messages::sendMessage(string message, int port, long diff) {
    int k = count_a;
    times_a = (k*times_a) / (k+1) + diff / (k+1);
    count_a++;

    pthread_mutex_lock(&queue_mutex);
    timeb t;
    ftime(&t);
    waitingTime.push(t);
    waitingMessages.push(message);
    waitingPorts.push(port);
    ftime (&timeIn);
    pthread_mutex_unlock(&queue_mutex);
}

Messages::~Messages() {
}


